{-# OPTIONS_GHC -Wall #-}
{-# LANGUAGE NoMonomorphismRestriction #-}
import Data.Conduit
import Control.Monad
import Control.Monad.IO.Class

prompter :: Source (ResourceT IO) Int
prompter = 
  bracketP (putStrLn "Hi!") 
           (\_ -> putStrLn "Bye") $ \_ ->
    forever $ do
      i <- liftIO $ putStr "> " >> readLn
      yield i

printer :: Sink Int (ResourceT IO) () 
printer = awaitForever $ liftIO . print 

fib :: Monad m => Int -> ConduitM i o m Int  
fib 0 = return 1
fib 1 = return 1
fib n = do
  n_2 <- fib (n - 2) 
  n_1 <- fib (n - 1)
  return (n_2 + n_1)

-- mapPipeM :: (a -> Pipe a b b) -> Pipe a b r
mapPipeM :: Monad m => (i -> ConduitM i o m o) -> ConduitM i o m ()
mapPipeM p = awaitForever $ \a -> do 
  b <- p a
  yield b

fibPipe :: Monad m => ConduitM Int Int m ()
fibPipe = mapPipeM fib 

main :: IO ()
main = runResourceT $ prompter $= fibPipe $$ printer

-- Leftovers break the law!

idPipe :: Monad m => ConduitM o o m ()
idPipe = awaitForever yield

main2A :: IO (Maybe Bool)
main2A = forever (yield False) $$ ((idPipe =$= leftover True) >> await)

main2B :: IO (Maybe Bool)
main2B = forever (yield False) $$ (            leftover True  >> await)
