import Control.Proxy
import Control.Proxy.Safe

prompter :: Proxy p => () -> Producer (ExceptionP p) Int SafeIO r
prompter () = 
  bracket_ id (putStrLn "Hi!") 
              (putStrLn "Bye") $ 
    forever $ do
      i <- tryIO $ putStr "> " >> readLn
      respond i

printer :: Proxy p => () -> Consumer (ExceptionP p) Int SafeIO r
printer () = forever $ do
  i <- request ()
  tryIO $ print i 

-- Intentionally slow fib
fib :: Proxy p => Int -> () -> (ExceptionP p) a' a b' b SafeIO Int 
fib 0 () = return 1
fib 1 () = return 1
fib n () = do
  n_2 <- fib (n - 2) ()
  n_1 <- fib (n - 1) ()
  return (n_2 + n_1)

mapPipeM  :: (Monad m, Proxy p) 
          => (a -> () -> ExceptionP p () a b' b m b) 
          -> () -> ExceptionP p () a b' b m r
mapPipeM p () = forever $ do
  a <- request ()
  b <- p a ()
  respond b

main :: IO ()
main = runSafeIO . runProxy . runEitherK $ 
  prompter >-> mapPipeM fib >-> printer
